<?php
/**
 * Created by JetBrains PhpStorm.
 * User: gustavoavila
 * Date: 22/11/12
 * Time: 15:05
 * To change this template use File | Settings | File Templates.
 */
namespace Facilities\Util;
class Facade
{
    protected $_storedInSession;

    public function __construct()
    {
        $this->_storage = new Storage();
    }
    
    protected function setFieldsStoredInSession(array $fields, $context)
    {
        $this->_storedInSession = $fields;
        $this->getValuesFromSessionToStorage($fields, $context);
    }
    
    protected function getValueFromSession($fieldName)
    {
        return $this->_storage->getSession()->getValue(strtolower($fieldName));
    }

    protected function getAllValuesFromSession()
    {
        return $this->_storage->getSession()->getData();
    }

    /**
    * Magic method call
    *
    * @param string $name Func name.
    * @param array  $args Func parameters.
    *
    * @return void|mixed
    */
    public function __call($name, array $args)
    {
       switch($name) {
           case (substr($name, 0, 3) === 'get'): {
               $fieldName = substr($name, 3, strlen($name));
               return tk_get_field_value($fieldName);
           }
           case (substr($name, 0, 3) === 'set'):{
               $fieldName = substr($name, 3, strlen($name));
               $tabName = isset($args[1]) ? $args[1] : null;
               $windowName = isset($args[2]) ? $args[2] : null;
               tk_set_field_value($fieldName, $args[0], $tabName, $windowName);
              break;
           }
           default:
               break;
       }
    }

    private function getValuesFromSessionToStorage($fields, $context)
    {
        foreach ($fields as $svar) {
            try {
                $this->_storage->getSession()->addData(tk_get_context_vars($svar, $context), strtolower($svar));
            } catch(\Exception $e) {
                continue;
            }
        }
    }
}
class Storage
{
    private $session;

    public function __construct()
    {
        $this->session = new SimpleStorage();
    }

    public function setSessionData($data)
    {
        $this->session->setData($data);
    }

    /**
     * @return SimpleStorage
     */
    public function getSession()
    {
        return $this->session;
    }
}


class SimpleStorage
{
    protected $data = array();
    
    public function getData()
    {
        return $this->data;
    }

    public function setData($data)
    {
        $this->data = $data;
    }

    public function getValue($index)
    {
        return isset($this->data[$index]) ? $this->data[$index] : null;
    }

    public function addData($data, $index = null)
    {
        if(isset($index)) {
            $this->data[$index] = $data;
        } else {
            $this->data[] = $data;
        }
    }
}